/*!
 * @file        main.c
 *
 * @brief       Main program body
 *
 * @version     V1.0.0
 *
 * @date        2025-01-01
 *
 * @attention
 *
 *  Copyright (C) 2025 Geehy Semiconductor
 *
 *  You may not use this file except in compliance with the
 *  GEEHY COPYRIGHT NOTICE (GEEHY SOFTWARE PACKAGE LICENSE).
 *
 *  The program is only for reference, which is distributed in the hope
 *  that it will be useful and instructional for customers to develop
 *  their software. Unless required by applicable law or agreed to in
 *  writing, the program is distributed on an "AS IS" BASIS, WITHOUT
 *  ANY WARRANTY OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the GEEHY SOFTWARE PACKAGE LICENSE for the governing permissions
 *  and limitations under the License.
 */

/* Includes ***************************************************************/
#include "main.h"
#include <stdio.h>
#include "bmp561_tmr.h"
#include "bmp561_gpio.h"
#include "bmp561_sysctrl.h"

/* Private includes *******************************************************/

/* Private macro **********************************************************/

/* Private typedef ********************************************************/

/* Private variables ******************************************************/

/* Private function prototypes ********************************************/
void TMR_Init(void);
void GPIO_Init(void);

/* External variables *****************************************************/

/* External functions *****************************************************/

/*!
 * @brief   Main program
 *
 * @param   None
 *
 * @retval  None
 */
int main(void)
{
    /* After 3 seconds delay, SWD pin will be occupied */
    BOARD_Delay_Config();
    GPIO_Reset();
    BOARD_Delay_Ms(3000);

    GPIO_Init();
    TMR_Init();

    while (1)
    {
    }
}

/*!
 * @brief   TMR initialization
 *
 * @param   None
 *
 * @retval  None
 */
void TMR_Init(void)
{
    SYSCTRL_Unlock();
    SYSCTRL_EnableAPBPeriphBCGClock(SYSCTRL_APB_TMR0);
    SYSCTRL_EnableAPBPeriphWCGClock(SYSCTRL_APB_TMR0);
    SYSCTRL_Lock();

    TMR_ConfigMode(TMR0, TMR_MODE_PWM);

    /* TMR frequency = 4MHz / 4 = 1MHz */
    TMR_ConfigClockDiv(TMR0, TMR_DIV_4);
    /* PWM frequency = 1MHz / 1000 = 1000Hz */
    TMR_SetCounter(TMR0, 1000);
    TMR_PWM_ConfigDutyRatio(TMR0, 500);
    TMR_PWM_ConfigPolarity(TMR0, TMR_PWM_POL_HIGH);
    TMR_Enable(TMR0);
}

/*!
 * @brief   GPIO initialization
 *
 * @param   None
 *
 * @retval  None
 */
void GPIO_Init(void)
{
    GPIO_Config_T gpioConfig;

    SYSCTRL_Unlock();
    SYSCTRL_EnableAHBPeriphClock(SYSCTRL_AHB_GPIO);
    SYSCTRL_Lock();

    GPIO_ConfigStructInit(&gpioConfig);
    gpioConfig.pin = GPIO_PIN_0;
    gpioConfig.mode = GPIO_MODE_AF;
    gpioConfig.speed = GPIO_OS_HIGH;
    gpioConfig.type = GPIO_OT_PP;
    gpioConfig.pullEn = DISABLE;
    gpioConfig.polarity = GPIO_POL_UP;
    gpioConfig.drive = GPIO_DS_HIGH;
    GPIO_Config(&gpioConfig);
    GPIO_ConfigPinReuse(GPIO_PIN_0, GPIO_REUSE_AF2);
}
